diff --git a/platform/linux-generic/include/odp_buffer_internal.h b/platform/linux-generic/include/odp_buffer_internal.h
index f8ebc7c..a1a6b4e 100644
--- a/platform/linux-generic/include/odp_buffer_internal.h
+++ b/platform/linux-generic/include/odp_buffer_internal.h
@@ -115,10 +115,3 @@ void odp_buffer_copy_scatter(odp_buffer_t buf_dst, odp_buffer_t buf_src);
 #endif
 
 #endif
-
-
-
-
-
-
-
diff --git a/platform/linux-generic/include/odp_internal.h b/platform/linux-generic/include/odp_internal.h
index fb3be79..22d90ef 100644
--- a/platform/linux-generic/include/odp_internal.h
+++ b/platform/linux-generic/include/odp_internal.h
@@ -44,10 +44,3 @@ int odp_timer_init_global(void);
 #endif
 
 #endif
-
-
-
-
-
-
-
diff --git a/platform/linux-generic/include/odp_packet_internal.h b/platform/linux-generic/include/odp_packet_internal.h
index 792fc7c..eb978a3 100644
--- a/platform/linux-generic/include/odp_packet_internal.h
+++ b/platform/linux-generic/include/odp_packet_internal.h
@@ -142,4 +142,3 @@ void odp_packet_parse(odp_packet_t pkt, size_t len, size_t l2_offset);
 #endif
 
 #endif
-
diff --git a/platform/linux-generic/include/odp_packet_io_internal.h b/platform/linux-generic/include/odp_packet_io_internal.h
index 3ab7fa0..881cc5f 100644
--- a/platform/linux-generic/include/odp_packet_io_internal.h
+++ b/platform/linux-generic/include/odp_packet_io_internal.h
@@ -47,4 +47,3 @@ typedef union {
 #endif
 
 #endif
-
diff --git a/platform/linux-generic/include/odp_packet_io_queue.h b/platform/linux-generic/include/odp_packet_io_queue.h
index 18e55f6..d5f9850 100644
--- a/platform/linux-generic/include/odp_packet_io_queue.h
+++ b/platform/linux-generic/include/odp_packet_io_queue.h
@@ -47,4 +47,3 @@ int pktout_deq_multi(queue_entry_t *queue, odp_buffer_hdr_t *buf_hdr[],
 #endif
 
 #endif
-
diff --git a/platform/linux-generic/include/odp_packet_netmap.h b/platform/linux-generic/include/odp_packet_netmap.h
index 0c75c7f..57d9f2c 100644
--- a/platform/linux-generic/include/odp_packet_netmap.h
+++ b/platform/linux-generic/include/odp_packet_netmap.h
@@ -46,7 +46,7 @@ typedef struct {
  * Configure an interface to work in netmap mode
  */
 int setup_pkt_netmap(pkt_netmap_t * const pkt_nm, char *netdev,
-		   odp_buffer_pool_t pool, netmap_params_t *nm_params);
+		     odp_buffer_pool_t pool, netmap_params_t *nm_params);
 
 /**
  * Switch interface from netmap mode to normal mode
@@ -57,11 +57,11 @@ int close_pkt_netmap(pkt_netmap_t * const pkt_nm);
  * Receive packets using netmap
  */
 int recv_pkt_netmap(pkt_netmap_t * const pkt_nm, odp_packet_t pkt_table[],
-		  unsigned len);
+		    unsigned len);
 
 /**
  * Send packets using netmap
  */
 int send_pkt_netmap(pkt_netmap_t * const pkt_nm, odp_packet_t pkt_table[],
-		  unsigned len);
+		    unsigned len);
 #endif
diff --git a/platform/linux-generic/include/odp_packet_socket.h b/platform/linux-generic/include/odp_packet_socket.h
index 0dccd95..f6248b2 100644
--- a/platform/linux-generic/include/odp_packet_socket.h
+++ b/platform/linux-generic/include/odp_packet_socket.h
@@ -80,7 +80,7 @@ int setup_pkt_sock(pkt_sock_t * const pkt_sock, const char *netdev,
 		   odp_buffer_pool_t pool);
 
 int setup_pkt_sock_mmap(pkt_sock_mmap_t * const pkt_sock, const char *netdev,
-		   odp_buffer_pool_t pool, int fanout);
+			odp_buffer_pool_t pool, int fanout);
 
 /**
  * Close a packet socket
@@ -93,22 +93,22 @@ int close_pkt_sock_mmap(pkt_sock_mmap_t * const pkt_sock);
  * Receive packets from the packet socket
  */
 int recv_pkt_sock_basic(pkt_sock_t * const pkt_sock, odp_packet_t pkt_table[],
-		  unsigned len);
+			unsigned len);
 
 int recv_pkt_sock_mmsg(pkt_sock_t * const pkt_sock, odp_packet_t pkt_table[],
-		  unsigned len);
+		       unsigned len);
 
 int recv_pkt_sock_mmap(pkt_sock_mmap_t * const pkt_sock,
-		  odp_packet_t pkt_table[], unsigned len);
+		       odp_packet_t pkt_table[], unsigned len);
 /**
  * Send packets through the packet socket
  */
 int send_pkt_sock_basic(pkt_sock_t * const pkt_sock, odp_packet_t pkt_table[],
-		  unsigned len);
+			unsigned len);
 
 int send_pkt_sock_mmsg(pkt_sock_t * const pkt_sock, odp_packet_t pkt_table[],
-		  unsigned len);
+		       unsigned len);
 
 int send_pkt_sock_mmap(pkt_sock_mmap_t * const pkt_sock,
-		  odp_packet_t pkt_table[], unsigned len);
+		       odp_packet_t pkt_table[], unsigned len);
 #endif
diff --git a/platform/linux-generic/include/odp_spin_internal.h b/platform/linux-generic/include/odp_spin_internal.h
index ec04e3c..b7e2071 100644
--- a/platform/linux-generic/include/odp_spin_internal.h
+++ b/platform/linux-generic/include/odp_spin_internal.h
@@ -30,20 +30,20 @@ static inline void odp_spin(void)
 {
 #if defined __x86_64__ || defined __i386__
 
-	#ifdef __SSE2__
+#ifdef __SSE2__
 	__asm__ __volatile__ ("pause");
-	#else
+#else
 	__asm__ __volatile__ ("rep; nop");
-	#endif
+#endif
 
 #elif defined __arm__
 
-	#if __ARM_ARCH == 7
+#if __ARM_ARCH == 7
 	__asm__ __volatile__ ("nop");
 	__asm__ __volatile__ ("nop");
 	__asm__ __volatile__ ("nop");
 	__asm__ __volatile__ ("nop");
-	#endif
+#endif
 
 #elif defined __OCTEON__
 